////////////////////
@Field App
App = "App2"
////////////////////////////////////////
//import libraries
import groovy.transform.Field


//import classes
//Importing Classes
import ContactSensor.ContactSensor
import ContactSensor.ContactSensors
import DoorControl.DoorControl
import DoorControl.DoorControls
import Lock.Lock
import Lock.Locks
import Thermostat.Thermostat
import Thermostat.Thermostats
import Switch.Switch
import Switch.Switches
import PresenceSensor.PresenceSensor
import PresenceSensor.PresenceSensors
import Logger.Logger
import Location.LocationVar
import Location.Phrase
import appTouch.Touched
import NfcTouch.NfcTouch
import AeonKeyFob.AeonKeyFob
import AeonKeyFob.AeonKeyFobs
import MusicPlayer.MusicPlayer
import MusicPlayer.MusicPlayers
import MotionSensor.MotionSensor
import MotionSensor.MotionSensors
import ImageCapture.ImageCapture
import ImageCapture.ImageCaptures
import SmokeDetector.SmokeDetector
import SmokeDetector.SmokeDetectors
import Alarm.Alarm
import Alarm.Alarms
import SpeechSynthesis.SpeechSynthesis
import SpeechSynthesis.SpeechSynthesises
import Timer.SimulatedTimer

//GlobalVariables
@Field def location = new LocationVar()
//Settings variable defined to settings on purpose
@Field def settings = [app: "app"]
//Global variable for state[mode]
@Field def state = [home:[],away:[],night:[]]
//Create a global logger object for methods
@Field def log = new Logger()
//Create a global variable for optional property
@Field def optional = false //by default for now


//Global variables for files
@Field File extractedObjectsApp1 = new File("Extractor/App1/extractedObjectsApp1.groovy")
@Field File extractedObjectsApp2 = new File("Extractor/App2/extractedObjectsApp2.groovy")
@Field File extractedObjectsConstructorApp1 = new File("Extractor/App1/extractedObjectsConstructorApp1.groovy")
@Field File extractedObjectsConstructorApp2 = new File("Extractor/App2/extractedObjectsConstructorApp2.groovy")


//Empty the files
if (App == "App1") {
	extractedObjectsApp1.write("")
	extractedObjectsConstructorApp1.write("")
} else if (App == "App2") {
	extractedObjectsApp2.write("")
	extractedObjectsConstructorApp2.write("")
}





//Global objects
//Global Object for class Touch Sensor!
@Field touchSensorObjects = 0
@Field def touchSensorObject0
@Field def touchSensorObject1
@Field def touchSensorObject2
//Global Object for class switch!
@Field switchObjects = 0
@Field def switchObject0
@Field def switchObject1
@Field def switchObject2
//Global Object for class lock!
@Field lockObjects = 0
@Field def lockObject0
@Field def lockObject1
@Field def lockObject2
//Global Object for class door control!
@Field doorControlObjects = 0
@Field def doorControlObject0
@Field def doorControlObject1
@Field def doorControlObject2
//Global Object for class contact sensor!
@Field contactObjects = 0
@Field def contactObject0
@Field def contactObject1
@Field def contactObject2
//Global Object for class presence sensor!
@Field presenceSensorObjects = 0
@Field def presenceSensorObject0
@Field def presenceSensorObject1
@Field def presenceSensorObject2
//Global Object for class thermostat!
@Field thermostatObjects = 0
@Field def thermostatObject0
@Field def thermostatObject1
@Field def thermostatObject2
//Global Object for class music player!
@Field musicPlayerObjects = 0
@Field def musicPlayerObject0
@Field def musicPlayerObject1
@Field def musicPlayerObject2
//Global Object for class music player!
@Field aeonKeyFobObjects = 0
@Field def aeonKeyFobObject0
@Field def aeonKeyFobObject1
@Field def aeonKeyFobObject2
//Global Object for class motion sensor!
@Field motionSensorObjects = 0
@Field def motionSensorObject0
@Field def motionSensorObject1
@Field def motionSensorObject2
//Global Object for class image capture!
@Field imageCaptureObjects = 0
@Field def imageCaptureObject0
@Field def imageCaptureObject1
@Field def imageCaptureObject2
//Global Object for class smoke detector!
@Field smokeDetectorObjects = 0
@Field def smokeDetectorObject0
@Field def smokeDetectorObject1
@Field def smokeDetectorObject2
//Global Object for class alarm!
@Field alarmObjects = 0
@Field def alarmObject0
@Field def alarmObject1
@Field def alarmObject2
//Global Object for class alarm!
@Field speechSynthesisObjects = 0
@Field def speechSynthesisObject0
@Field def speechSynthesisObject1
@Field def speechSynthesisObject2


//Global variables
//For mode
@Field modeVariables = 0
@Field mode0
@Field mode1
@Field mode2
@Field mode3
@Field mode4
@Field mode5
//For number
@Field numberVariables = 0
@Field number0
@Field number1
@Field number2
@Field number3
@Field number4
@Field number5
//For decimal
@Field decimalVariables = 0
@Field decimal0
@Field decimal1
@Field decimal2
@Field decimal3
@Field decimal4
@Field decimal5
//For time
@Field timeVariables = 0
@Field time0
@Field time1
@Field time2
@Field time3
@Field time4
@Field time5
//For enum
@Field enumVariables = 0
@Field enum0
@Field enum1
@Field enum2
@Field enum3
@Field enum4
@Field enum5
//For phone
@Field phoneVariables = 0
@Field phone0
@Field phone1
@Field phone2
@Field phone3
@Field phone4
@Field phone5
//For contact
@Field contactVariables = 0
@Field contact0
@Field contact1
@Field contact2
@Field contact3
@Field contact4
@Field contact5
//For text
@Field textVariables = 0
@Field textVariable0
@Field textVariable1
@Field textVariable2
@Field textVariable3
@Field textVariable4
@Field textVariable5
//For boolean
@Field boolVariables = 0
@Field boolVariable0
@Field boolVariable1
@Field boolVariable2
@Field boolVariable3
@Field boolVariable4
@Field boolVariable5


/////Input Methods/////
//input "",""
def input(String name, String type) {
	LinkedHashMap metaData = []
	metaData.put('name',name)
	metaData.put('type',type)
	input(metaData)
}

//input "","",linkedHashMap
def input(LinkedHashMap metaData, String name, String type) {
	metaData.put('name',name)
	metaData.put('type',type)
	input(metaData)
}

//input "", "", linkedHashMap, Closure
def input(LinkedHashMap metaData, String name, String type, Closure Input) {
	metaData.put('name',name)
	metaData.put('type',type)
	input(metaData)
	find(Input)
}

//input linkedHashMap
def input(LinkedHashMap metaData) {
	if (metaData.containsKey('title')) {
		println metaData['title']
	}
	if (metaData.containsKey('options')) {
		println "Options: "+metaData['options']
	}
	switch(metaData['type']) {
		case "capability.lock":
			if (lockObjects == 0) {
				lockObject0 = metaData['name']
				this[lockObject0] = new Locks({}, 1)
			} else if (lockObjects == 1) {
				lockObject1 = metaData['name']
				this[lockObject1] = new Locks({}, 1)
			} else if (lockObjects == 2) {
				lockObject2 = metaData['name']
				this[lockObject2] = new Locks({}, 1)
			}

			lockObjects=lockObjects+1

			settings.put(metaData['name'], metaData['name']) 

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class lock!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.lockObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class lock!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.lockObject\n")
			}
			break
		case "capability.alarm":
			if (alarmObjects == 0) {
				alarmObject0 = metaData['name']
				this[alarmObject0] = new Alarms({}, 1)
			} else if (alarmObjects == 1) {
				alarmObject1 = metaData['name']
				this[alarmObject1] = new Alarms({}, 1)
			} else if (alarmObjects == 2) {
				alarmObject2 = metaData['name']
				this[alarmObject2] = new Alarms({}, 1)
			}

			alarmObjects=alarmObjects+1

			settings.put(metaData['name'], metaData['name']) 

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class alarm!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.alarmObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class alarm!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.alarmObject\n")
			}
			break
		case "capability.battery":
			break
		case "capability.beacon":
			break
		case "capability.carbonMonoxideDetector":
			break
		case "capability.colorControl":
			break
		case "capability.contactSensor":
			if (contactObjects == 0) {
				contactObject0 = metaData['name']
				this[contactObject0] = new ContactSensors({}, 1)
			} else if (contactObjects == 1) {
				contactObject1 = metaData['name']
				this[contactObject1] = new ContactSensors({}, 1)
			} else if (contactObjects == 2) {
				contactObject2 = metaData['name']
				this[contactObject2] = new ContactSensors({}, 1)
			}

			contactObjects=contactObjects+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class contactSensor!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.contactObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class contactSensor!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.contactObject\n")
			}
			break
		case "capability.doorControl":
			if (doorControlObjects == 0) {
				doorControlObject0 = metaData['name']
				this[doorControlObject0] = new DoorControls({}, 1)
			} else if (doorControlObjects == 1) {
				doorControlObject1 = metaData['name']
				this[doorControlObject1] = new DoorControls({}, 1)
			} else if (doorControlObjects == 2) {
				doorControlObject2 = metaData['name']
				this[doorControlObject2] = new DoorControls({}, 1)
			}

			doorControlObjects=doorControlObjects+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class door control!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.doorControlObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class door control!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.doorControlObject\n")
			}
			break
		case "capability.energyMeter":
			break
		case "capability.illuminanceMeasurement":
			break
		case "capability.accelerationSensor":
			break
		case "capability.motionSensor":
			if (motionSensorObjects == 0) {
				motionSensorObject0 = metaData['name']
				this[motionSensorObject0] = new MotionSensors({}, 1)
			} else if (motionSensorObjects == 1) {
				motionSensorObject1 = metaData['name']
				this[motionSensorObject1] = new MotionSensors({}, 1)
			} else if (motionSensorObjects == 2) {
				motionSensorObject2 = metaData['name']
				this[motionSensorObject2] = new MotionSensors({}, 1)
			}

			motionSensorObjects=motionSensorObjects+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class Motion Sensor!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.motionSensorObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class Motion Sensor!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.motionSensorObject\n")
			}
			break
		case "capability.musicPlayer":
			if (musicPlayerObjects == 0) {
				musicPlayerObject0 = metaData['name']
				this[musicPlayerObject0] = new MusicPlayers({}, 1)
			} else if (musicPlayerObjects == 1) {
				musicPlayerObject1 = metaData['name']
				this[musicPlayerObject1] = new MusicPlayers({}, 1)
			} else if (musicPlayerObjects == 2) {
				musicPlayerObject2 = metaData['name']
				this[musicPlayerObject2] = new MusicPlayers({}, 1)
			}

			musicPlayerObjects=musicPlayerObjects+1

			settings.put(metaData['name'], metaData['name']) 

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class music player!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.musicPlayerObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class music player!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.musicPlayerObject\n")
			}
			break
		case "capability.powerMeter":
			break
		case "capability.presenceSensor":
			if (presenceSensorObjects == 0) {
				presenceSensorObject0 = metaData['name']
				this[presenceSensorObject0] = new PresenceSensors({}, 1)
			} else if (presenceSensorObjects == 1) {
				presenceSensorObject1 = metaData['name']
				this[presenceSensorObject1] = new PresenceSensors({}, 1)
			} else if (presenceSensorObjects == 2) {
				presenceSensorObject2 = metaData['name']
				this[presenceSensorObject2] = new PresenceSensors({}, 1)
			}

			presenceSensorObjects=presenceSensorObjects+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class presence sensor!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.presenceSensorObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class presence sensor!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.presenceSensorObject\n")
			}
			break
		case "capability.relativeHumidityMeasurement":
			break
		case "capability.relaySwitch":
			break
		case "capability.sleepSensor":
			break
		case "capability.smokeDetector":
			if (smokeDetectorObjects == 0) {
				smokeDetectorObject0 = metaData['name']
				this[smokeDetectorObject0] = new SmokeDetectors({}, 1)
			} else if (smokeDetectorObjects == 1) {
				smokeDetectorObject1 = metaData['name']
				this[smokeDetectorObject1] = new SmokeDetectors({}, 1)
			} else if (smokeDetectorObjects == 2) {
				smokeDetectorObject2 = metaData['name']
				this[smokeDetectorObject2] = new SmokeDetectors({}, 1)
			}

			smokeDetectorObjects=smokeDetectorObjects+1
			
			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class smoke detector!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.smokeDetectorObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class smoke detector!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.smokeDetectorObject\n")
			}
			break
		case "capability.stepSensor":
			break
		case "capability.switch":
			if (switchObjects == 0) {
				switchObject0 = metaData['name']
				this[switchObject0] = new Switches({}, 1)
			} else if (switchObjects == 1) {
				switchObject1 = metaData['name']
				this[switchObject1] = new Switches({}, 1)
			} else if (switchObjects == 2) {
				switchObject2 = metaData['name']
				this[switchObject2] = new Switches({}, 1)
			}

			switchObjects=switchObjects+1
			
			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class switch!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.switchObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class switch!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.switchObject\n")
			}
			break
		case "capability.switchLevel":
			break
		case "capability.temperatureMeasurement":
			break
		case "capability.thermostat":
			if (thermostatObjects == 0) {
				thermostatObject0 = metaData['name']
				this[thermostatObject0] = new Thermostats({}, 1)
			} else if (thermostatObjects == 1) {
				thermostatObject1 = metaData['name']
				this[thermostatObject1] = new Thermostats({}, 1)
			} else if (thermostatObjects == 2) {
				thermostatObject2 = metaData['name']
				this[thermostatObject2] = new Thermostats({}, 1)
			}

			thermostatObjects=thermostatObjects+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class thermostat!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.thermostatObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class thermostat!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.thermostatObject\n")
			}
			break
		case "capability.valve":
			break
		case "capability.speechSynthesis":
			if (speechSynthesisObjects == 0) {
				speechSynthesisObject0 = metaData['name']
				this[speechSynthesisObject0] = new SpeechSynthesises({}, 1)
			} else if (speechSynthesisObjects == 1) {
				speechSynthesisObject1 = metaData['name']
				this[speechSynthesisObject1] = new SpeechSynthesises({}, 1)
			} else if (speechSynthesisObjects == 2) {
				speechSynthesisObject2 = metaData['name']
				this[speechSynthesisObject2] = new SpeechSynthesises({}, 1)
			}

			speechSynthesisObjects=speechSynthesisObjects+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class speech synthesis!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.speechSynthesisObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class speech synthesis!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.speechSynthesisObject\n")
			}
			break
		case "capability.waterSensor":
			break
		case "capability.touchSensor":
			if (touchSensorObjects == 0) {
				touchSensorObject0 = metaData['name']
				this[touchSensorObject0] = new NfcTouch({}, 1)
			} else if (touchSensorObjects == 1) {
				touchSensorObject1 = metaData['name']
				this[touchSensorObject1] = new NfcTouch({}, 1)
			} else if (touchSensorObjects == 2) {
				touchSensorObject2 = metaData['name']
				this[touchSensorObject2] = new NfcTouch({}, 1)
			}

			touchSensorObjects=touchSensorObjects+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class Touch Sensor!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.touchSensorObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class Touch Sensor!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.touchSensorObject\n")
			}
			break
		case "capability.imageCapture":
			if (imageCaptureObjects == 0) {
				imageCaptureObject0 = metaData['name']
				this[imageCaptureObject0] = new ImageCaptures({}, 1)
			} else if (imageCaptureObjects == 1) {
				imageCaptureObject1 = metaData['name']
				this[imageCaptureObject1] = new ImageCaptures({}, 1)
			} else if (imageCaptureObjects == 2) {
				imageCaptureObject2 = metaData['name']
				this[imageCaptureObject2] = new ImageCaptures({}, 1)
			}

			imageCaptureObjects=imageCaptureObjects+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class Image Capture!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.imageCaptureObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class Image Capture!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.imageCaptureObject\n")
			}
			break
		case "device.mobilePresence":
			break
		case "device.aeonKeyFob":
			if (aeonKeyFobObjects == 0) {
				aeonKeyFobObject0 = metaData['name']
				this[aeonKeyFobObject0] = new AeonKeyFobs({}, 1)
			} else if (aeonKeyFobObjects == 1) {
				aeonKeyFobObject1 = metaData['name']
				this[aeonKeyFobObject1] = new AeonKeyFobs({}, 1)
			} else if (aeonKeyFobObjects == 2) {
				aeonKeyFobObject2 = metaData['name']
				this[aeonKeyFobObject2] = new AeonKeyFobs({}, 1)
			}

			aeonKeyFobObjects=aeonKeyFobObjects+1

			settings.put(metaData['name'], metaData['name']) 

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class aeon key fob!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.aeonKeyFobObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class aeon key fob!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.aeonKeyFobObject\n")
			}
			break
		case "mode":
			def randomVariable = Math.abs(new Random().nextInt() % 3)
			def modes = ["away", "home", "night"]
			def userInput = modes[randomVariable]

			if (modeVariables == 0) {
				mode0 = metaData['name']
				this[mode0] = userInput
			} else if (modeVariables == 1) {
				mode1 = metaData['name']
				this[mode1] = userInput
			} else if (modeVariables == 2) {
				mode2 = metaData['name']
				this[mode2] = userInput
			} else if (modeVariables == 3) {
				mode3 = metaData['name']
				this[mode3] = userInput
			} else if (modeVariables == 4) {
				mode4 = metaData['name']
				this[mode4] = userInput
			} else if (modeVariables == 5) {
				mode5 = metaData['name']
				this[mode5] = userInput
			}

			modeVariables=modeVariables+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {			
				extractedObjectsApp1.append("//Global variable for mode!\n")
				extractedObjectsApp1.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			} else {
				extractedObjectsApp2.append("//Global variable for mode!\n")
				extractedObjectsApp2.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			}
			break
		case "decimal":
			def userInput = Math.abs(new Random().nextInt() % 60) + 40
			
			if (decimalVariables == 0) {
				decimal0 = metaData['name']
				this[decimal0] = userInput
			} else if (decimalVariables == 1) {
				decimal1 = metaData['name']
				this[decimal1] = userInput
			} else if (decimalVariables == 2) {
				decimal2 = metaData['name']
				this[decimal2] = userInput
			} else if (decimalVariables == 3) {
				decimal3 = metaData['name']
				this[decimal3] = userInput
			} else if (decimalVariables == 4) {
				decimal4 = metaData['name']
				this[decimal4] = userInput
			} else if (decimalVariables == 5) {
				decimal5 = metaData['name']
				this[decimal5] = userInput
			}

			decimalVariables=decimalVariables+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {			
				extractedObjectsApp1.append("//Global variable for decimal number!\n")
				extractedObjectsApp1.append("def "+metaData['name']+" = "+userInput+"\n")
			} else {
				extractedObjectsApp2.append("//Global variable for decimal number!\n")
				extractedObjectsApp2.append("def "+metaData['name']+" = "+userInput+"\n")
			}
			break
		case "text":
			def userInput = "This is just a text!"
	
			if (textVariables == 0) {
				text0 = metaData['name']
				this[text0] = userInput
			} else if (textVariables == 1) {
				text1 = metaData['name']
				this[text1] = userInput
			} else if (textVariables == 2) {
				text2 = metaData['name']
				this[text2] = userInput
			} else if (textVariables == 3) {
				text3 = metaData['name']
				this[text3] = userInput
			} else if (textVariables == 4) {
				text4 = metaData['name']
				this[text4] = userInput
			} else if (textVariables == 5) {
				text5 = metaData['name']
				this[text5] = userInput
			}

			textVariables=textVariables+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {			
				extractedObjectsApp1.append("//Global variable for text!\n")
				extractedObjectsApp1.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			} else {
				extractedObjectsApp2.append("//Global variable for text!\n")
				extractedObjectsApp2.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			}
			break
		case "number":
			def userInput = Math.abs(new Random().nextInt() % 60) + 40
			
			if (numberVariables == 0) {
				number0 = metaData['name']
				this[number0] = userInput
			} else if (numberVariables == 1) {
				number1 = metaData['name']
				this[number1] = userInput
			} else if (numberVariables == 2) {
				number2 = metaData['name']
				this[number2] = userInput
			} else if (numberVariables == 3) {
				number3 = metaData['name']
				this[number3] = userInput
			} else if (numberVariables == 4) {
				number4 = metaData['name']
				this[number4] = userInput
			} else if (numberVariables == 5) {
				number5 = metaData['name']
				this[number5] = userInput
			}

			numberVariables=numberVariables+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {			
				extractedObjectsApp1.append("//Global variable for number!\n")
				extractedObjectsApp1.append("def "+metaData['name']+" = "+userInput+"\n")
			} else {
				extractedObjectsApp2.append("//Global variable for number!\n")
				extractedObjectsApp2.append("def "+metaData['name']+" = "+userInput+"\n")
			}
			break
		case "time":
			def userInput = "15:00"
			
			if (timeVariables == 0) {
				time0 = metaData['name']
				this[time0] = userInput
			} else if (timeVariables == 1) {
				time1 = metaData['name']
				this[time1] = userInput
			} else if (timeVariables == 2) {
				time2 = metaData['name']
				this[time2] = userInput
			} else if (timeVariables == 3) {
				time3 = metaData['name']
				this[time3] = userInput
			} else if (timeVariables == 4) {
				time4 = metaData['name']
				this[time4] = userInput
			} else if (timeVariables == 5) {
				time5 = metaData['name']
				this[time5] = userInput
			}

			timeVariables=timeVariables+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {			
				extractedObjectsApp1.append("//Global variable for time!\n")
				extractedObjectsApp1.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			} else {
				extractedObjectsApp2.append("//Global variable for time!\n")
				extractedObjectsApp2.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			}
			break
		case "enum":
			def randomVariable = Math.abs(new Random().nextInt() % 2)
			def modes = ["Yes", "No"]
			def userInput = modes[randomVariable]
	
			if (enumVariables == 0) {
				enum0 = metaData['name']
				this[enum0] = userInput
			} else if (enumVariables == 1) {
				enum1 = metaData['name']
				this[enum1] = userInput
			} else if (enumVariables == 2) {
				enum2 = metaData['name']
				this[enum2] = userInput
			} else if (enumVariables == 3) {
				enum3 = metaData['name']
				this[enum3] = userInput
			} else if (enumVariables == 4) {
				enum4 = metaData['name']
				this[enum4] = userInput
			} else if (enumVariables == 5) {
				enum5 = metaData['name']
				this[enum5] = userInput
			}

			enumVariables=enumVariables+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {			
				extractedObjectsApp1.append("//Global variable for enum!\n")
				extractedObjectsApp1.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			} else {
				extractedObjectsApp2.append("//Global variable for enum!\n")
				extractedObjectsApp2.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			}
			break
		case "bool":
			def userInput = Math.abs(new Random().nextInt() % 2)
	
			if (boolVariables == 0) {
				bool0 = metaData['name']
				this[bool0] = userInput
			} else if (boolVariables == 1) {
				bool1 = metaData['name']
				this[bool1] = userInput
			} else if (boolVariables == 2) {
				bool2 = metaData['name']
				this[bool2] = userInput
			} else if (boolVariables == 3) {
				bool3 = metaData['name']
				this[bool3] = userInput
			} else if (boolVariables == 4) {
				bool4 = metaData['name']
				this[bool4] = userInput
			} else if (boolVariables == 5) {
				bool5 = metaData['name']
				this[bool5] = userInput
			}

			boolVariables=boolVariables+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {			
				extractedObjectsApp1.append("//Global variable for boolean!\n")
				extractedObjectsApp1.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			} else {
				extractedObjectsApp2.append("//Global variable for boolean!\n")
				extractedObjectsApp2.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			}
			break
		case "phone":
			def userInput = 9495379373

			if (phoneVariables == 0) {
				phone0 = metaData['name']
				this[phone0] = userInput
			} else if (phoneVariables == 1) {
				phone1 = metaData['name']
				this[phone1] = userInput
			} else if (phoneVariables == 2) {
				phone2 = metaData['name']
				this[phone2] = userInput
			} else if (phoneVariables == 3) {
				phone3 = metaData['name']
				this[phone3] = userInput
			} else if (phoneVariables == 4) {
				phone4 = metaData['name']
				this[phone4] = userInput
			} else if (phoneVariables == 5) {
				phone5 = metaData['name']
				this[phone5] = userInput
			}

			phoneVariables=phoneVariables+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {			
				extractedObjectsApp1.append("//Global variable for phone!\n")
				extractedObjectsApp1.append("def "+metaData['name']+" = "+userInput+"\n")
			} else {
				extractedObjectsApp2.append("//Global variable for phone!\n")
				extractedObjectsApp2.append("def "+metaData['name']+" = "+userInput+"\n")
			}
			break
		case "contact":
			def userInput = "AJ"
	
			if (contactVariables == 0) {
				contact0 = metaData['name']
				this[contact0] = userInput
			} else if (contactVariables == 1) {
				contact1 = metaData['name']
				this[contact1] = userInput
			} else if (contactVariables == 2) {
				contact2 = metaData['name']
				this[contact2] = userInput
			} else if (contactVariables == 3) {
				contact3 = metaData['name']
				this[contact3] = userInput
			} else if (contactVariables == 4) {
				contact4 = metaData['name']
				this[contact4] = userInput
			} else if (contactVariables == 5) {
				contact5 = metaData['name']
				this[contact5] = userInput
			}

			contactVariables=contactVariables+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {			
				extractedObjectsApp1.append("//Global variable for contact!\n")
				extractedObjectsApp1.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			} else {
				extractedObjectsApp2.append("//Global variable for contact!\n")
				extractedObjectsApp2.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			}
			break
		default:
			break
	}
}

def label(LinkedHashMap metaData) {
	if (metaData.containsKey('title')) {
		println metaData['title']
	}
	if (metaData.containsKey('options')) {
		println "Options: "+metaData['options']
	}

	println("//IGNORE--ForMobileUse//")
}

def mode(LinkedHashMap metaData) {
	if (metaData.containsKey('title')) {
		println metaData['title']
	}
	if (metaData.containsKey('options')) {
		println "Options: "+metaData['options']
	}

	println("//IGNORE--ForMobileUse//")
}

def href(LinkedHashMap metaData) {
	println("//IGNORE--some data//")
}
/////Input Methods/////


/////MethodsForExtraction/////
def definition(LinkedHashMap metaData) {
	println("///Just some information///")
}

def preferences(Closure inputData) {
	find(inputData) //Run the closure to extract pages/sections/inputMethods
	if (App == "App1") {			
		extractedObjectsConstructorApp1.append("//Global variable for settings!\n")
		extractedObjectsConstructorApp1.append("settings = $settings\n")
	} else {
		extractedObjectsConstructorApp2.append("//Global variable for settings!\n")
		extractedObjectsConstructorApp2.append("settings = $settings\n")
	}
}

def page(LinkedHashMap metaData, Closure inputData) {
	if (metaData.containsKey('name'))
		println(metaData['name'])
	if (metaData.containsKey('title'))
		println(metaData['title'])

	find(inputData) //Run the closure to extract sections/inputMethods
}

def page(LinkedHashMap metaData) {
	def nameOfFunction = metaData['name']
	"$nameOfFunction"() //Call the page	
}

def dynamicPage(LinkedHashMap metaData, Closure inputData) {
	if (metaData.containsKey('name'))
		println(metaData['name'])
	if (metaData.containsKey('title'))
		println(metaData['title'])

	find(inputData) //Run the closure to extract sections/inputMethods
}

def paragraph(String paragraphText) {
	println(paragraphText)
}

def section(String title, Closure inputData) {
	println(title)
	find(inputData) //Run the closure to extract inputMethods
}

def section(Closure inputData) {
	find(inputData) //Run the closure to extract inputMethods
}

def section(LinkedHashMap metaData, Closure inputData) {
	find(inputData) //Run the closure to extract inputMethods
}
/////MethodsForExtraction/////



/**
 *  NFC Tag Toggle
 *
 *  Copyright 2014 SmartThings
 *
 *  Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License. You may obtain a copy of the License at:
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software distributed under the License is distributed
 *  on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License
 *  for the specific language governing permissions and limitations under the License.
 *
 */
 
definition(
    name: "NFC Tag Toggle",
    namespace: "smartthings",
    author: "SmartThings",
    description: "Allows toggling of a switch, lock, or garage door based on an NFC Tag touch event",
    category: "SmartThings Internal",
    iconUrl: "https://s3.amazonaws.com/smartapp-icons/Developers/nfc-tag-executor.png",
    iconX2Url: "https://s3.amazonaws.com/smartapp-icons/Developers/nfc-tag-executor@2x.png",
    iconX3Url: "https://s3.amazonaws.com/smartapp-icons/Developers/nfc-tag-executor@2x.png")


preferences {
    page(name: "pageOne", title: "Device selection", uninstall: true, nextPage: "pageTwo") {
        section("Select an NFC tag") {
            input "tag", "capability.touchSensor", title: "NFC Tag"
        }
        section("Select devices to control") {
            input "switch1", "capability.switch", title: "Light or switch", required: false, multiple: true
            input "lock", "capability.lock", title: "Lock", required: false, multiple: true
            input "garageDoor", "capability.doorControl", title: "Garage door controller", required: false, multiple: true
        }
    }
    
    page(name: "pageTwo", title: "Master devices", install: true, uninstall: true)
}

def pageTwo() {
	dynamicPage(name: "pageTwo") {
    	section("If set, the state of these devices will be toggled each time the tag is touched, " + 
                "e.g. a light that's on will be turned off and one that's off will be turned on, " +
                "other devices of the same type will be set to the same state as their master device. " +
                "If no master is designated then the majority of devices of the same type will be used " +
                "to determine whether to turn on or off the devices.") {
            
            if (switch1 || masterSwitch) {
                input "masterSwitch", "enum", title: "Master switch", options: switch1.collect{[(it.id): it.displayName]}, required: false
            }
            if (lock || masterLock) {
                input "masterLock", "enum", title: "Master lock", options: lock.collect{[(it.id): it.displayName]}, required: false
            }
            if (garageDoor || masterDoor) {
                input "masterDoor", "enum", title: "Master door", options: garageDoor.collect{[(it.id): it.displayName]}, required: false
            }            
		}
		section([mobileOnly:true]) {
			label title: "Assign a name", required: false
			mode title: "Set for specific mode(s)", required: false
		}        
    }
}

def installed() {
	log.debug "Installed with settings: ${settings}"

	initialize()
}

def updated() {
	log.debug "Updated with settings: ${settings}"

	unsubscribe()
	initialize()
}

def initialize() {
	subscribe tag, "nfcTouch", touchHandler
    subscribe app, touchHandler
}

private currentStatus(devices, master, attribute) {
	log.trace "currentStatus($devices, $master, $attribute)"
	def result = null
	if (master) {
    	result = devices.find{it.id == master}?.currentValue(attribute)
    }
    else {
    	def map = [:]
        devices.each {
        	def value = it.currentValue(attribute)
            map[value] = (map[value] ?: 0) + 1
            log.trace "$it.displayName: $value"
        }
        log.trace map
        result = map.collect{it}.sort{it.value}[-1].key
    }
    log.debug "$attribute = $result"
    result
}

def touchHandler(evt) {
	log.trace "touchHandler($evt.descriptionText)"
    if (switch1) {
    	def status = currentStatus(switch1, masterSwitch, "switch")
        switch1.each {
            if (status == "on") {
                it.off()
            }
            else {
                it.on()
            }
        }
    }
    
    if (lock) {
    	def status = currentStatus(lock, masterLock, "lock")
        lock.each {
            if (status == "locked") {
                lock.unlock()
            }
            else {
                lock.lock()
            }
        }
    }
    
    if (garageDoor) {
        def status = currentStatus(garageDoor, masterDoor, "status")
    	garageDoor.each {
        	if (status == "open") {
            	it.close()
            }
            else {
            	it.open()
            }
        }
    }
}
