//Create a class for image capture sensor
package ImageCapture
import Timer.SimulatedTimer

public class ImageCaptures {
	private int deviceNumbers
	private List imageCaptureSensors
	def sendEvent

	//For one device(We cannot have obj.id)-> We should have obj[0].id
	private String id = "motionSensorID0"
	private String label = "motionSensor0"
	private String displayName = "motionSensor0"
	private String image = "imageData"
	private String alarmState = "armed"

		
	ImageCaptures(Closure sendEvent, int deviceNumbers) {
		this.sendEvent = sendEvent		
		this.deviceNumbers = deviceNumbers
		this.imageCaptureSensors = []

		imageCaptureSensors.add(new ImageCapture(id, label, displayName, this.image, this.alarmState))
	}


	//Methods for closures
	def count(Closure Input) {
		imageCaptureSensors.count(Input)
	}
	def size() {
		imageCaptureSensors.size()
	}
	def each(Closure Input) {
		imageCaptureSensors.each(Input)
	}
	def find(Closure Input) {
		imageCaptureSensors.find(Input)
	}
	def collect(Closure Input) {
		imageCaptureSensors.collect(Input)
	}

	def alarmOn() {
		imageCaptureSensors[0].alarmOn()
		this.alarmState = "armed"
	}

	def alarmOff() {
		imageCaptureSensors[0].alarmOff()
		this.alarmState = "not armed"
	}

	def take() {
		imageCaptureSensors[0].take()
	}
	def getAt(int ix) {
		imageCaptureSensors[ix]
	}
}
