//Create a class for lock device
package Lock
import Timer.SimulatedTimer

public class Locks{
	int deviceNumbers	
	List locks	
	def sendEvent	
	def timers

	//When we have only one device
	private String id = "lockID0"
	private String label = "lock0"
	private String displayName = "lock0"
	private String lockState = "locked"
	private String currentLock = "locked"
	private String lockLatestValue = "locked"

	Locks(Closure sendEvent, int deviceNumbers) {
		this.sendEvent = sendEvent
		this.timers = new SimulatedTimer()
		this.deviceNumbers = deviceNumbers
		this.locks = []

		locks.add(new Lock(sendEvent,id, label, displayName, this.lockState, this.lockLatestValue))
	}

	//By Apps
	def lock() {
		locks[0].lock()
		lockLatestValue = lockState
		lockState = "locked"
		currentLock = "locked"
	}

	def lock(LinkedHashMap metaData) {
		def task = timers.runAfter(metaData["delay"]) {
			locks[0].lock()
			lockLatestValue = lockState
			lockState = "locked"
			currentLock = "locked"
		}
	}

	def unlock() {
		locks[0].unlock()
		lockLatestValue = lockState
		lockState = "unlocked"
		currentLock = "unlocked"
	}


	def unlock(LinkedHashMap metaData) {
		def task = timers.runAfter(metaData["delay"]) {
			locks[0].unlock()
			lockLatestValue = lockState
			lockState = "unlocked"
			currentLock = "unlocked"
		}
	}

	//Methods for closures
	def count(Closure Input) {
		locks.count(Input)
	}
	def size() {
		locks.size()
	}
	def each(Closure Input) {
		locks.each(Input)
	}
	def find(Closure Input) {
		locks.find(Input)
	}
	def collect(Closure Input) {
		locks.collect(Input)
	}

	//By Model Checker
	def setValue(LinkedHashMap eventDataMap) {
		if (eventDataMap["value"] != locks[0].lockState) {
			locks[0].setValue(eventDataMap["value"])
			this.lockState = locks[0].lockState
			this.currentLock = locks[0].lockState
			this.lockLatestValue = locks[0].lockLatestValue
			sendEvent(eventDataMap)
		}
	}

	def currentValue(String deviceFeature) {
		locks[0].currentValue(deviceFeature)
	}

	def latestValue(String deviceFeature) {
		locks[0].latestValue(deviceFeature)
	}

	def getAt(int ix) {
		locks[ix]
	}
}

