//Create a class for switch device
package Switch
import Timer.SimulatedTimer

public class Switches {
	int deviceNumbers	
	List switches
	def timers
	def sendEvent

	//If we have only one device
	private String id = "switchID0"
	private String label = "switch0"
	private String displayName = "switch0"
	private String switchState = "off"
	private String currentSwitch = "off"
	private int currentLevel = 50
	private String switchLatestValue = "off"

	Switches(Closure sendEvent, int deviceNumbers) {
		this.sendEvent = sendEvent
		this.timers = new SimulatedTimer()
		this.deviceNumbers = deviceNumbers
		this.switches = []

		switches.add(new Switch(sendEvent, id, label, displayName, this.switchState, this.currentSwitch, this.currentLevel, this.switchLatestValue))
	}

	//Methods for closures
	def count(Closure Input) {
		switches.count(Input)
	}
	def size() {
		switches.size()
	}
	def each(Closure Input) {
		switches.each(Input)
	}
	def find(Closure Input) {
		switches.find(Input)
	}
	def collect(Closure Input) {
		switches.collect(Input)
	}

	//By Apps
	def setLevel(int level) {
		switches[0].setLevel(level)
		currentLevel = level
	}

	def on() {
		switches[0].on()
		switchLatestValue = switchState
		switchState = "on"
		currentSwitch = "on"
	}

	def on(LinkedHashMap metaData) {
		def task = timers.runAfter(metaData["delay"]) {
			switches[0].on()
			switchLatestValue = switchState
			switchState = "on"
			currentSwitch = "on"
		}
	}

	def off() {
		switches[0].off()
		switchLatestValue = switchState
		switchState = "off"
		currentSwitch = "off"
	}

	def off(LinkedHashMap metaData) {
		def task = timers.runAfter(metaData["delay"]) {
			switches[0].off()
			switchLatestValue = switchState
			switchState = "off"
			currentSwitch = "off"
		}
	}

	//By Model Checker
	def setValue(LinkedHashMap eventDataMap) {
		if (eventDataMap["value"] != switches[0].switchState) {
			switches[0].setValue(eventDataMap["value"])
			this.switchState = switches[0].switchState
			this.switchLatestValue = switches[0].switchLatestValue
			sendEvent(eventDataMap)
		}
	}


	def currentValue(String deviceFeature) {
		switches[0].currentValue(deviceFeature)
	}

	def latestValue(String deviceFeature) {
		switches[0].latestValue(deviceFeature)
	}

	def getAt(int ix) {
		switches[ix]
	}
}
